package gcewing.blocks;

public class Matrix3 {

	public static Matrix3[] blockRotations = {
		Matrix3.rotY(0), Matrix3.rotY(90), Matrix3.rotY(180), Matrix3.rotY(270)
	};

	public double m[][] = new double[][] {
		{1, 0, 0},
		{0, 1, 0},
		{0, 0, 1}
	};
		
	public static Matrix3 rotY(double deg) {
		return rot(deg, 2, 0);
	}
	
	static Matrix3 rot(double deg, int i, int j) {
		double a = Math.toRadians(deg);
		double s = Math.sin(a);
		double c = Math.cos(a);
		Matrix3 r = new Matrix3();
		r.m[i][i] = c;
		r.m[i][j] = -s;
		r.m[j][i] = s;
		r.m[j][j] = c;
		return r;
	}

	public Vector3 mul(double x, double y, double z) {
		return new Vector3(
			x * m[0][0] + y * m[1][0] + z * m[2][0],
			x * m[0][1] + y * m[1][1] + z * m[2][1],
			x * m[0][2] + y * m[1][2] + z * m[2][2]
		);
	}
	
	public Vector3 mul(Vector3 v) {
		return mul(v.x, v.y, v.z);
	}

}
